;# ===========================================================================
;#  Dateiname:	.../ar_spin.lsp
;# ===========================================================================
;#  Bearbeiter:  	Thomas Drner
;#  Stand:		31.10.2003
;# ===========================================================================
;#  Beschreibung:  Drehen mit Dichte und Farbwerten
;# ===========================================================================

;# ===========================================================================
;;### alle Befehle werden in custom - frei whlbar - gepackt
;# ===========================================================================
(in-package :EXAMPLES)

;# ===========================================================================
;;### Lade Befehlssatz fr Integration Kit
;# ===========================================================================
(use-package :OLI)	

;# ===========================================================================
;;### Tabelle
;# ===========================================================================
;;### Logische Tabelle
(sd-create-logical-table "Teile_sDichte"
	:columns	  		'(:beschreibung :dichte :abk :spez_dichte  :farbe)
  	:columnNames	'(" Beschreibung " " kg/dm^3 " " - " " g/mm^3 " " Farbe ")
    	:types 			'(:string :string :string :number :number)
	:contents       '(
					("Stahl" "7,85" "St"  0.00785  8355711)  ;; 127,127,127
					("Aluminium" "2,75" "Al" 0.00275  11842740)  ;; 180,180,180
					("Bronze" "8,45" "CuSn" 0.00845 6576700) ;; 100,90,60
					("Magnesium" "1,89" "Mg" 0.00189 11842740) ;; 180,180,180
					("Messing" "8,50" "CuZn" 0.00850 7237180) ;; 140,140,60
					("Kupfer" "8,96" "Cu" 0.00896  6566415) ;; 100,50,15
					("Glas" "2,40" "Glas" 0.00240 16777215) ;; 255,255,255				
					("PTFE" "2,20" "PTFE" 0.00220 16777215) ;; 255,255,255
					("ABS/PS" "1,00" "ABS/PS" 0.00100 16777215) ;; 255,255,255
					("PA" "1,13" "PA" 0.00113 16777215) ;; 255,255,255
					("PC" "1,20" "PC" 0.00120 16777215) ;; 255,255,255
					("PMMA" "1,18" "PMMA" 0.00118 16777215) ;; 255,255,255
					("POM/PVC" "1,40" "POM/PVC" 0.00140 16777215) ;; 255,255,255
					("PP" "0,90" "PP" 0.00090 16777215) ;; 255,255,255
					("PU-Kompakt" "1,30" "PU-C" 0.00130 16777215) ;; 255,255,255
					("PU-Schaum" "0,59" "PU-F" 0.00059 16777215) ;; 255,255,255					
					("Jurid z.B. 421" "2,50" "Jurid" 0.0025  2712436) ;; 40,99,116					
					("Silikonkautschuk" "1,50" "Gummi" 0.0015  0) ;;0,0,0
					("Papier" "0,95" "Papier" 0.00095  16777215) ;; 255,255,255	
					("Hartpapier" "1,40" "Hp/Hgw" 0.00140  5921330) ;; 90,90,50
					("Transtherm T1500" "1,50" "T1500-10" 0.00150  5921330) ;; 90,90,50
					("CPU TC-PAD" "2,80" "SBC" 0.00280  5921330) ;; 90,90,50
				 )
) ;; logical table

;;### Display Tabelle
(sd-create-display-table "sDichte_Tab"
    	:tableTitle		"spezifische Dichte"
    	:logicalTable		"Teile_sDichte"
    	:columns        	'(:beschreibung :dichte :abk :spez_dichte  :farbe)
    	:applyColumns	'(:spez_dichte :farbe)
	:selectionMode      :single-row 
	:applyAction 		:default
) ;; ende display table

;# ===========================================================================
;;### Dialog
;# ===========================================================================
(sd-defdialog 'td_spin
	:toolbox-button nil
	:dialog-title "Drehen m. Material"
	:variables
	'(
		("Teiledaten")
		(ID
			:value-type :string
			:title "Ident-Nr"
			:initial-value "x0."
     			:prompt-text "Gib die Ident-Nummer ein")
 
 		(BEZEICH
			:value-type :string
			:title "Bezeichnung"
			:initial-value "Name"
     			:prompt-text "Gib die Bezeichnung ein")

		(ZCHNGNR
			:value-type :string
			:title "Zchng.-Nr"
			:initial-value "0000-"
     			:prompt-text "Gib die Zeichnungs-Nummer ein")     
     			;:after-input (td-lege-neues-teil-an ID BEZEICH ZCHNGNR)			    			
			
#|		(TEIL  
			:value-type :part-incl-new  
     			:title "Teil" 
     			:initial-value 	(if (sd-inq-curr-part) 
     							(sd-inq-curr-part) 
     							(format nil "/~A_~A_~A" ID BEZEICH ZCHNGNR) ;;(sd-gen-obj-basename :part))
     						) ;; end if
   			:prompt-text "Selektiere Arbeitsebene")
|#
		("Parameter")
		(MATERIAL
          		:value-type :list						;; da zur auswahl mehrere stehen
          		:title "Werkstoff"
          		:show-input-tool
          	 		(sd-show-display-table "sDichte_Tab" :position '("NEUE_DICHTE-OPTIONS-OPT-CONT-WERTE-TB" :bottomleft -6 32)) ;; Aufruf der Display Table
          		:hide-input-tool 
       		      (sd-hide-display-table "sDichte_Tab"))	;; Verstecken der Display Table      

    		(AEBENE
    			 :value-type :wp-with-profile
 			 :title "AE"
     			:prompt-text "Selektiere Arbeitsebene")
     			
		(ACHSE
     			:value-type :measure-axis 
     			:title "Achse"
     			:prompt-text "Rotationsachse auswhlen")
         
		(WINKEL
			:value-type :angle
			:title "Winkel"
     			:prompt-text "Rotationswinkel eingeben")
     			
#|     		(B_WP
     			:title "AE behalt"
     			:initial-value t
     			:value-type :grouped-boolean)
     		
     		(B_PR
     			:title "Profil beh."
     			:initial-value t
     			:value-type :grouped-boolean)
|#     			
     			
     	) ;; end variables
      
  	:ok-action
  		'(sd-call-cmds
    			(progn
    			
    				(setq TNAME (format nil "~A_~A_~A" ID BEZEICH ZCHNGNR))
    				;(display tname)
    				
    				(create_part :name TNAME)
    				
    				(setq TEIL (sd-inq-curr-part))
    			
				(turn 
					:part TEIL
					:wp AEBENE
					;:rotation-angle (* (/ PI 180) WINKEL)
					:rotation-angel WINKEL
					:axis (first ACHSE) (second ACHSE)
					:keep_wp :yes
					:keep_profile :yes)						
	   			
	   			(set_part_density TEIL (FIRST MATERIAL))
				
				(set_part_inst_color
						:parts TEIL
						:color :color (SECOND MATERIAL) 
						:done)
										
			) ;; ende progn
	)  ;; ende ok-action
) ;; ende dialog
